<template>
    <div class="service-container" v-if="state.servicePage == 1">
        <div
            class="
                offset-9
                col-lg-2 col-md-3 col-xs-6
                q-mr-md-lg q-mr-xs-sm
                row
                justify-end
            "
        >
            <q-btn
                no-caps
                text-color="white"
                :label="$t('button.createService')"
                @click="state.servicePage = 2"
                class="button-save"
            />
        </div>
        <div class="col-12 border-radius-20 service q-pa-md scroll">
            <vue-data-table
                :headers="serviceType"
                :data="serviceData(state.serviceList)"
                :actions="serviceActions"
                :editServiceType="editServiceType"
            />
        </div>
    </div>
    <div class="service-container" v-else-if="state.servicePage == 2">
        <create-service @update-servicePage="updateServicePage" />
    </div>
    <div class="service-container" v-else-if="state.servicePage == 3">
        <update-service
            :service="state.currentService"
            @update-servicePage="updateServicePage"
        />
    </div>
</template>
<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
/* eslint-disable @typescript-eslint/no-explicit-any*/
/* eslint-disable @typescript-eslint/no-floating-promises */
import { useStore } from 'src/store';
import { useI18n } from 'vue-i18n';
import { defineComponent, computed, watch, reactive, onMounted } from 'vue';
import VueDataTable from 'src/components/datatable/VueDataTable.vue';
import CreateService from 'src/components/serviceType/CreateService.vue';
import UpdateService from 'src/components/serviceType/UpdateService.vue';

export default defineComponent({
    name: 'ServiceList',
    components: {
        VueDataTable,
        CreateService,
        UpdateService
    },
    setup() {
        const store = useStore();
        const { t } = useI18n();
        const lang = store.state.user.user?.locale;

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        const updateServicePage = (value: any) => {
            state.servicePage = value;
        };

        let state = reactive({
            serviceList: computed(() => {
                return store.state.service.serviceType;
            }),
            serviceTypeList: [] as any,
            servicePage: 1,
            currentService: {} as any,
            serviceId: ''
        });

        const serviceActions = ['editService'];

        //Service Table Header
        const serviceType = [
            t('preference.serviceName', {}, { locale: lang }),
            t('preference.serviceChild', {}, { locale: lang }),
            t('tables.actions', {}, { locale: lang })
        ];

        //watch
        watch(selectedBusinessId, () => {
            if (selectedBusinessId.value) {
                getService();
            }
        });

        const getService = async () => {
            const res = await store.dispatch('service/getServiceTypeList', {
                businessId: selectedBusinessId.value
            });
            if (res) {
                state.serviceId = res.result.serviceTypes.id;
            }
        };

        const editServiceType = (data: any) => {
            if (data.childName) {
                const findIndex = state.serviceList.findIndex(
                    (element: any) => element.name == data.childName
                );
                if (findIndex != -1) {
                    state.currentService = state.serviceList[findIndex];
                    state.servicePage = 3;
                }
            } else {
                const findIndex = state.serviceList.findIndex(
                    (element: any) => element.name == data.name
                );
                if (findIndex != -1) {
                    state.currentService = state.serviceList[findIndex];
                    state.servicePage = 3;
                }
            }
        };

        const removeServiceType = async () => {
            await store.dispatch('service/delete', {
                serviceTypeId: state.serviceId
            });
        };

        const serviceData = (data: any) => {
            let resultsList: any = [];

            let service = {
                name: '' as string,
                childName: '' as string
            };

            data.forEach((element: any) => {
                if (element.parentId == null) {
                    service = {
                        name: element.name,
                        childName: ''
                    };
                    resultsList.push(service);
                }
                data.forEach((element2: any) => {
                    if (element2.parentId == element.id) {
                        service = {
                            name: element.name,
                            childName: element2.name
                        };
                        resultsList.push(service);
                    }
                });
            });
            return resultsList;
        };

        onMounted(getService);

        return {
            state,
            updateServicePage,
            serviceType,
            serviceData,
            serviceActions,
            editServiceType,
            removeServiceType
        };
    }
});
</script>
